package domaine.temps;

public class ValeurTropGrandeDuJour extends Exception {
	public ValeurTropGrandeDuJour(int jour, int mois, int annee) {
		super("valeur trop grande du jour (" + jour + ") pour le mois de "
	        + Date.nomDuMois(mois)
	        + " (maximum " + (mois == 2 ? (Date.bissextile(annee) ? "29 en " + annee : "28") : "30")
	        + annee + " (maximum 29)"
	        + ")");
	}
}
