package outils;

import outils.ListeChainee.ElementDeListe;

public class ListeChaineeTriable<Type extends Comparable<Type>>
extends ListeChainee<Type>
implements ListeTriable<Type> {
	public ListeChaineeTriable() {
		super();
	}
	private void echangeContenusDe(ElementDeListe e1, ElementDeListe e2) {
        Type svg = e1.contenu;
        e1.contenu = e2.contenu;
        e2.contenu = svg;
	}
	private int desordre() {
		int desordre = 0, indiceCourant = 1;
		ElementDeListe elementCourant, elementSuivant;
		elementSuivant = (elementCourant = premier).suivant;
		while(elementSuivant != null) {
            if ((elementCourant.contenu).compareTo(elementSuivant.contenu) > 0) {
            	desordre += indiceCourant;
            }
            elementCourant = elementCourant.suivant;
            elementSuivant = elementSuivant.suivant;
			indiceCourant++;
		}
		return desordre;
	}
	private boolean estEnPetitDesordre() {
		return desordre() < (nbElem * (nbElem + 1)) / 4;
	}
	public void trie() {
        if (nbElem < 2) return;
        boolean echange = true;
        ElementDeListe courant, suivant;
        while(echange) {
            courant = premier;
            suivant = courant.suivant;
            echange = false;
            while (suivant != null) {
                if (((Type)courant.contenu).compareTo((Type)suivant.contenu) > 0) {
                    echangeContenusDe(courant, suivant);
                    echange = true;
                }
                courant = suivant;
                suivant = courant.suivant;
            }
        }
	}
}
