package outils;

public class ListeTableauTriable<Type extends Comparable<Type>>
extends ListeTableau<Type>
implements ListeTriable<Type> {
	protected void echangeContenusDe(int indice1, int indice2) {
		Object svg = contenu[indice1];
		contenu[indice1] = contenu[indice2];
		contenu[indice2] = svg;
	}
	@SuppressWarnings("unchecked")
	private int desordre() {
		int desordre = 0;
		int indiceCourant, indiceSuivant;
		for(indiceSuivant = 1 + (indiceCourant = 0); indiceSuivant < nbElem; indiceCourant++, indiceSuivant++) {
            if (((Type)contenu[indiceCourant]).compareTo((Type)contenu[indiceSuivant]) > 0) {
            	desordre += indiceCourant + 1;
            }
		}
		return desordre;
	}
	private boolean estEnPetitDesordre() {
		return desordre() < (nbElem * (nbElem + 1)) / 4;
	}
	@SuppressWarnings("unchecked")
	public void trie() {	
        if (nbElem < 2) return;
        boolean echange = true;
        int indiceCourant, indiceSuivant;
        while(echange) {
            echange = false;
            for(indiceSuivant = (indiceCourant = 0) + 1; indiceSuivant < nbElem; indiceCourant++, indiceSuivant++) {
                if (((Type)contenu[indiceCourant]).compareTo((Type)contenu[indiceSuivant]) > 0) {
                    echangeContenusDe(indiceCourant, indiceSuivant);
                    echange = true;
                }
            }
        }
	}
}
