package outils;

import java.util.Iterator;

public class AdaptateurDeParcours<Type> implements Iterator<Type> {
	private Parcours<Type> adapté;
	public AdaptateurDeParcours(Parcours<Type> parcours) {
		adapté = parcours;
	}
	public boolean hasNext() {
		return adapté.encore();
	}
	public Type next() {
		Type element = adapté.elementCourant();
		adapté.suivant();
		return element;
	}
	public void remove() {
		adapté.precedent();
		adapté.supprime();
	}
}
